/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.InvoiceItemRecord;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class InvoiceItem extends TableImpl<InvoiceItemRecord> {

    private static final long serialVersionUID = 508291191;

    /**
     * The reference instance of <code>INVOICE_ITEM</code>
     */
    public static final InvoiceItem INVOICE_ITEM = new InvoiceItem();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<InvoiceItemRecord> getRecordType() {
        return InvoiceItemRecord.class;
    }

    /**
     * The column <code>INVOICE_ITEM.ID_ITEM</code>.
     */
    public final TableField<InvoiceItemRecord, Integer> ID_ITEM = createField("ID_ITEM", org.jooq.impl.SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>INVOICE_ITEM.ID_INVOICE</code>.
     */
    public final TableField<InvoiceItemRecord, Integer> ID_INVOICE = createField("ID_INVOICE", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>INVOICE_ITEM.DESCRIPTION</code>.
     */
    public final TableField<InvoiceItemRecord, Integer> DESCRIPTION = createField("DESCRIPTION", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>INVOICE_ITEM.INVOICE_POSITION</code>.
     */
    public final TableField<InvoiceItemRecord, Integer> INVOICE_POSITION = createField("INVOICE_POSITION", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>INVOICE_ITEM.TOTAL</code>.
     */
    public final TableField<InvoiceItemRecord, BigDecimal> TOTAL = createField("TOTAL", org.jooq.impl.SQLDataType.DECIMAL(34, 20).nullable(false), this, "");

    /**
     * The column <code>INVOICE_ITEM.NOTE</code>.
     */
    public final TableField<InvoiceItemRecord, String> NOTE = createField("NOTE", org.jooq.impl.SQLDataType.VARCHAR(100), this, "");

    /**
     * The column <code>INVOICE_ITEM.TOTAL_ORIG_CURRENCY</code>.
     */
    public final TableField<InvoiceItemRecord, BigDecimal> TOTAL_ORIG_CURRENCY = createField("TOTAL_ORIG_CURRENCY", org.jooq.impl.SQLDataType.DECIMAL(34, 20).nullable(false), this, "");

    /**
     * The column <code>INVOICE_ITEM.ORIG_CURRENCY</code>.
     */
    public final TableField<InvoiceItemRecord, String> ORIG_CURRENCY = createField("ORIG_CURRENCY", org.jooq.impl.SQLDataType.CHAR(3).nullable(false), this, "");

    /**
     * Create a <code>INVOICE_ITEM</code> table reference
     */
    public InvoiceItem() {
        this(DSL.name("INVOICE_ITEM"), null);
    }

    /**
     * Create an aliased <code>INVOICE_ITEM</code> table reference
     */
    public InvoiceItem(String alias) {
        this(DSL.name(alias), INVOICE_ITEM);
    }

    /**
     * Create an aliased <code>INVOICE_ITEM</code> table reference
     */
    public InvoiceItem(Name alias) {
        this(alias, INVOICE_ITEM);
    }

    private InvoiceItem(Name alias, Table<InvoiceItemRecord> aliased) {
        this(alias, aliased, null);
    }

    private InvoiceItem(Name alias, Table<InvoiceItemRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> InvoiceItem(Table<O> child, ForeignKey<O, InvoiceItemRecord> key) {
        super(child, key, INVOICE_ITEM);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.INVOICE_ITEM_INVOICE_ITEM_INDEX_01, Indexes.INVOICE_ITEM_INVOICE_ITEM_INDEX_02, Indexes.INVOICE_ITEM_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<InvoiceItemRecord, Integer> getIdentity() {
        return Keys.IDENTITY_INVOICE_ITEM;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<InvoiceItemRecord> getPrimaryKey() {
        return Keys.KEY_INVOICE_ITEM_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<InvoiceItemRecord>> getKeys() {
        return Arrays.<UniqueKey<InvoiceItemRecord>>asList(Keys.KEY_INVOICE_ITEM_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<InvoiceItemRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<InvoiceItemRecord, ?>>asList(Keys.FK_INVOICE_ITEM_INVOICE_ID, Keys.FK_INVOICE_ITEM_DESCRIPTION_INVOICE_ITEM);
    }

    public Invoice invoice() {
        return new Invoice(this, Keys.FK_INVOICE_ITEM_INVOICE_ID);
    }

    public ItemInvoiceReason itemInvoiceReason() {
        return new ItemInvoiceReason(this, Keys.FK_INVOICE_ITEM_DESCRIPTION_INVOICE_ITEM);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItem as(String alias) {
        return new InvoiceItem(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public InvoiceItem as(Name alias) {
        return new InvoiceItem(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public InvoiceItem rename(String name) {
        return new InvoiceItem(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public InvoiceItem rename(Name name) {
        return new InvoiceItem(name, null);
    }
}
